--[[
###############
Inked: keivamp#
###############
]]--
local AddOnName, Engine = ...
local _G = _G;
local unpack    = _G.unpack;
local select    = _G.select;
local Inked = select(2, ...)
local LSM = LibStub("LibSharedMedia-3.0")
local _G = _G;
local unpack        = _G.unpack;
local select        = _G.select;
local assert        = _G.assert;
local type          = _G.type;
local error         = _G.error;
local pcall         = _G.pcall;
local print         = _G.print;
local ipairs        = _G.ipairs;
local pairs         = _G.pairs;
local next          = _G.next;
local rawset        = _G.rawset;
local rawget        = _G.rawget;
local tostring      = _G.tostring;
local tonumber      = _G.tonumber;
local getmetatable  = _G.getmetatable;
local setmetatable  = _G.setmetatable;
local string        = _G.string;
local split         = string.split;
local upper         = string.upper;
local format        = string.format;
local find          = string.find;
local match         = string.match;
local gsub          = string.gsub;
local math          = _G.math;
local floor         = math.floor
local random        = math.random;
local table         = _G.table;
local tsort         = table.sort;
local tconcat       = table.concat;
local tremove       = _G.tremove;
local wipe          = _G.wipe;
local collectgarbage        = _G.collectgarbage;
local ERR_NOT_IN_COMBAT     = _G.ERR_NOT_IN_COMBAT;

local RequestBattlefieldScoreData = _G.RequestBattlefieldScoreData;
local InkedLib = Librarian("Registry");
_G.BINDING_HEADER_Inked = "Inked";
_G.Inked_ICON_COORDS = {0.1, 0.9, 0.1, 0.9};

local rez = GetCVar("gxWindowedResolution");
local baseHeight = tonumber(rez:match("%d+x(%d+)"))
local baseWidth = tonumber(rez:match("(%d+)x%d+"))
local defaultDockWidth = 450;
local defaultCenterWidth = min(defaultDockWidth, 900);
local callbacks = {};
local numCallbacks = 0;
local playerName = UnitName("player");
local playerRealm = GetRealmName();
local playerClass = select(2, UnitClass("player"));
local errorPattern = "|cffff0000Error -- |r|cffff9900Required addon '|r|cffffff00%s|r|cffff9900' is %s.|r";

local playerColor = RAID_CLASS_COLORS[select(2, UnitClass('player'))]
local InkedColors = {r = playerColor.r*0.75, g = playerColor.g*0.75,b = playerColor.b*0.75,a = 1}

_G.SHOWORHIDE = SHOW .. "\\" .. HIDE;
_G.MINIMIZEORMAXIMIZE = MINIMIZE .. "\\" .. WINDOWED_MAXIMIZED;

local Inked = InkedLib:NewCore("Inked_Global", "Inked_Errors", "Inked_Private", "Inked_Media", "Inked_Shared")

Inked.ConfigID           = "InkedOptions";
Inked.class              = playerClass;
Inked.GUID               = UnitGUID('player');
Inked.Allegiance         = UnitFactionGroup("player");
Inked.ClassRole          = "";
Inked.SpecificClassRole  = "NONE";

Inked.Screen = CreateFrame("Frame", "InkedParent", UIParent);
Inked.Screen:SetFrameLevel(UIParent:GetFrameLevel());
Inked.Screen:SetPoint("CENTER", UIParent, "CENTER");
Inked.Screen:SetSize(UIParent:GetSize());

Inked.Hidden = CreateFrame("Frame", nil, UIParent);
Inked.Hidden:Hide();

Inked.RollFrames         = {};
Inked.SystemAlert        = {};

InkedLib.CONSTRAINTS.IGNORED["LAYOUT"] = true;
InkedLib.CONSTRAINTS.IGNORED["REPORT_SLOTS"] = true;

InkedLib.CONSTRAINTS.PROTECTED["extended"] = true;
InkedLib.CONSTRAINTS.PROTECTED["shared"] = true;
InkedLib.CONSTRAINTS.PROTECTED["color"] = true;
InkedLib.CONSTRAINTS.PROTECTED["bordercolor"] = true;
InkedLib.CONSTRAINTS.PROTECTED["Filters"] = true;

local SetLoginMessage;
--Ink.Version = GetAddOnMetadata(AddOnName, "Version")
do
 
    local commandments = {
        {
            "Hello There",
            "Greetings",
            "Welcome",
            "Let's get ready to Warcraft",
            "Ready to Play",
			"Hi",
            "Hey",
            "*Waves*",
            "Time for a quest",
            "We got this",
        },
  
    };
    local messagePattern = "|cffFF2F00%s:|r";
    local debugPattern = "|cffFF2F00%s|r [|cff992FFF%s|r]|cffFF2F00:|r";
    local testPattern = "Version |cffAA78FF%s|r, Build |cffAA78FF%s|r."

    local function _send_message(msg)
        if(type(msg) == "table") then
             msg = tostring(msg)
        end
        if(not msg) then return end
        
            print(msg)
     
    end

    SetLoginMessage = function(self)
   
        local first = commandments[1][random(1,10)]     
		local login_msg1 = (first)
        _send_message(login_msg1)
		local login_msg2 = (" ")
        _send_message(login_msg2)
		 local login_msg3 = ("Inked Version 2.0.9")
        _send_message(login_msg3)
		 local login_msg4 = ("/Inked /Ink /nk to pull up the Config window")
        _send_message(login_msg4)
		local login_msg5 = ("/rl to reload the Interface")
        _send_message(login_msg5)
		local login_msg6 = ("Made by that noob keivamp (Kay - Vamp)")
        _send_message(login_msg6)
    end

   
end
function Inked:fubar() return end

function Inked:StaticPopup_Show(arg)
    if arg == "ADDON_ACTION_FORBIDDEN" then
        StaticPopup_Hide(arg)
    end
end

function Inked:PLAYER_ENTERING_WORLD()
	if(not InCombatLockdown()) then
        collectgarbage("collect")
    end
end

function Inked:PreLoad()
    self:RegisterEvent('PLAYER_REGEN_DISABLED');
    self:RegisterEvent("PLAYER_ENTERING_WORLD");
    -- self:RegisterEvent("UI_SCALE_CHANGED");
    self:RegisterEvent("PET_BATTLE_CLOSE");
    self:RegisterEvent("PET_BATTLE_OPENING_START");
    -- self:RegisterEvent("ADDON_ACTION_BLOCKED", "TaintHandler");
    -- self:RegisterEvent("ADDON_ACTION_FORBIDDEN", "TaintHandler");
    self:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED", "PlayerInfoUpdate");
    self:RegisterEvent("PLAYER_TALENT_UPDATE", "PlayerInfoUpdate");
    self:RegisterEvent("CHARACTER_POINTS_CHANGED", "PlayerInfoUpdate");
    self:RegisterEvent("UNIT_INVENTORY_CHANGED", "PlayerInfoUpdate");
    self:RegisterEvent("UPDATE_BONUS_ACTIONBAR", "PlayerInfoUpdate");
end
function Inked:Initialize()
	--InkedLib:Launch();
	SetLoginMessage(self);
	-- self:PlayerInfoUpdate();
end
-- Engine
-- Engine[1] = {} -- Ink, Main
-- Engine[2] = {} -- InkC, Config
-- local Ink, InkC,  = unpack(Engine)
-- local table_insert = _G.table.insert
-- local modules, initQueue = {}, {}

-- function Ink:RegisterModule(name)
	-- if modules[name] then print("Module <"..name.."> has been registered.") return end
	-- local module = {}
	-- module.name = name
	-- modules[name] = module

	-- tinsert(initQueue, module)
	-- return module
-- end
-- function Ink:NewModule(name)
	-- if modules[name] then
		-- print("Module ["..name.."] has already been registered.")
		-- return
	-- end

	-- local module = {}
	-- module.name = name
	-- modules[name] = module

	-- table_insert(initQueue, module)

	-- return module
-- end

-- function Ink:GetModule(name)
	-- if not modules[name] then
		-- print("Module <"..name.."> does not exist.")
		-- return
	-- end

	-- return modules[name]
-- end


-- _G[AddOnName] = Engine
--[[For Skinnning Start]]--
local _purgatory = CreateFrame("Frame", nil)
_purgatory:Hide()

local Die = function(self)
    if(self.UnregisterAllEvents) then
        self:UnregisterAllEvents()
        self:SetParent(_purgatory)
    else
        self:Hide()
        self.Show = Inked.fubar
    end
end

local RemoveTextures = function(self, option)
    if((not self.GetNumRegions) or (self.Panel and (not self.Panel.CanBeRemoved))) then return end
    local region, layer, texture
    for i = 1, self:GetNumRegions()do
        region = select(i, self:GetRegions())
        if(region and (region:GetObjectType() == "Texture")) then

            layer = region:GetDrawLayer()
            texture = region:GetTexture()

            if(option) then
                if(type(option) == "boolean") then
                    if region.UnregisterAllEvents then
                        region:UnregisterAllEvents()
                        region:SetParent(_purgatory)
                    else
                        region.Show = region.Hide
                    end
                    region:Hide()
                elseif(type(option) == "string" and ((layer == option) or (texture ~= option))) then
                    region:SetTexture("")
                end
            else
                region:SetTexture("")
            end
        end
    end
end
--[[For Skinnning End]]--
local LemonPledge = 0;
local Consuela = CreateFrame("Frame")
Consuela:RegisterAllEvents()
Consuela:SetScript("OnEvent", function(self, event)
    LemonPledge = LemonPledge  +  1
    ---- print(event) ----
    if(InCombatLockdown()) then return end;
    if(LemonPledge > 10000) then
        collectgarbage("collect");
        LemonPledge = 0;
    end
end)





local InkedLoginFrame=CreateFrame("Frame")
		InkedLoginFrame:RegisterEvent("PLAYER_LOGIN")
		InkedLoginFrame:RegisterEvent("CINEMATIC_STOP")
		InkedLoginFrame:SetScript("OnEvent", function(self, event) 
		
		end)